std::__debug::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >(3)

NAME
std::__debug::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > -

SYNOPSIS

Inherits unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >, and __gnu_debug::_Safe_unordered_container< unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > >.

  Public Types
typedef _Base::allocator_type allocator_type
typedef
__gnu_debug::_Safe_iterator
< _Base_const_iterator,
unordered_multimap > const_iterator"
typedef
__gnu_debug::_Safe_local_iterator
< _Base_const_local_iterator,
unordered_multimap > const_local_iterator"
typedef _Base::hasher hasher
typedef
__gnu_debug::_Safe_iterator
< _Base_iterator,
unordered_multimap > iterator"
typedef _Base::key_equal key_equal
typedef _Base::key_type key_type
typedef
__gnu_debug::_Safe_local_iterator
< _Base_local_iterator,
unordered_multimap > local_iterator"
typedef _Base::size_type size_type
typedef _Base::value_type value_type

  Public Member Functions
unordered_multimap (size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
template<typename _InputIterator > unordered_multimap (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
unordered_multimap (const unordered_multimap &)=default
unordered_multimap (const _Base &__x)
unordered_multimap (unordered_multimap &&)=default
unordered_multimap (const allocator_type &__a)
unordered_multimap (const unordered_multimap &__umap, const allocator_type &__a)
unordered_multimap (unordered_multimap &&__umap, const allocator_type &__a)
unordered_multimap (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
void _M_attach (_Safe_iterator_base *__it, bool __constant)
void _M_attach_local (_Safe_iterator_base *__it, bool __constant)
void _M_attach_local_single (_Safe_iterator_base *__it, bool __constant) throw ()
void _M_attach_single (_Safe_iterator_base *__it, bool __constant) throw ()
_Base & _M_base () noexcept
const _Base & _M_base () const noexcept
void _M_detach (_Safe_iterator_base *__it)
void _M_detach_local (_Safe_iterator_base *__it)
void _M_detach_local_single (_Safe_iterator_base *__it) throw ()
void _M_detach_single (_Safe_iterator_base *__it) throw ()
void _M_invalidate_all () const
void _M_invalidate_if (_Predicate __pred)
void _M_invalidate_local_if (_Predicate __pred)
iterator begin () noexcept
const_iterator begin () const noexcept
local_iterator begin (size_type __b)
const_local_iterator begin (size_type __b) const
size_type bucket_size (size_type __b) const
const_iterator cbegin () const noexcept
const_local_iterator cbegin (size_type __b) const
const_iterator cend () const noexcept
const_local_iterator cend (size_type __b) const
void clear () noexcept
template<typename... _Args> iterator emplace (_Args &&...__args)
template<typename... _Args> iterator emplace_hint (const_iterator __hint, _Args &&...__args)
iterator end () noexcept
const_iterator end () const noexcept
local_iterator end (size_type __b)
const_local_iterator end (size_type __b) const
std::pair< iterator, iterator > equal_range (const key_type &__key)
std::pair< const_iterator,
const_iterator > equal_range (const key_type &__key) const "
size_type erase (const key_type &__key)
iterator erase (const_iterator __it)
iterator erase (iterator __it)
iterator erase (const_iterator __first, const_iterator __last)
iterator find (const key_type &__key)
const_iterator find (const key_type &__key) const
iterator insert (const value_type &__obj)
iterator insert (const_iterator __hint, const value_type &__obj)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type> iterator insert (_Pair &&__obj)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type> iterator insert (const_iterator __hint, _Pair &&__obj)
void insert (std::initializer_list< value_type > __l)
template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
float max_load_factor () const noexcept
void max_load_factor (float __f)
unordered_multimap & operator= (const unordered_multimap &__x)
unordered_multimap & operator= (unordered_multimap &&__x) noexcept(_Alloc_traits::_S_nothrow_move())
unordered_multimap & operator= (initializer_list< value_type > __l)
void swap (unordered_multimap &__x) noexcept(_Alloc_traits::_S_nothrow_swap())

  Public Attributes
_Safe_iterator_base * _M_const_iterators
_Safe_iterator_base * _M_const_local_iterators
_Safe_iterator_base * _M_iterators
_Safe_iterator_base * _M_local_iterators
unsigned int _M_version

  Protected Member Functions
void _M_detach_all ()
void _M_detach_singular ()
__gnu_cxx::__mutex & _M_get_mutex () throw ()
void _M_revalidate_singular ()
void _M_swap (_Safe_unordered_container_base &__x)
void _M_swap (_Safe_sequence_base &__x)

Detailed Description

  template<typename _Key, typename _Tp, typename _Hash = std::hash<_Key>, typename _Pred = std::equal_to<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>class std::__debug::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >
Class std::unordered_multimap with safety/checking/debug instrumentation.

Definition at line 504 of file debug/unordered_map.

Member Function Documentation

  void __gnu_debug::_Safe_sequence_base::_M_attach (_Safe_iterator_base *__it, bool__constant) [inherited]
Attach an iterator to this sequence.

  void __gnu_debug::_Safe_unordered_container_base::_M_attach_local (_Safe_iterator_base *__it, bool__constant) [inherited]
Attach an iterator to this container.

  void __gnu_debug::_Safe_unordered_container_base::_M_attach_local_single (_Safe_iterator_base *__it, bool__constant) [inherited]
Likewise but not thread safe.

  void __gnu_debug::_Safe_sequence_base::_M_attach_single (_Safe_iterator_base *__it, bool__constant) [inherited]
Likewise but not thread safe.

  void __gnu_debug::_Safe_sequence_base::_M_detach (_Safe_iterator_base *__it) [inherited]
Detach an iterator from this sequence

  void __gnu_debug::_Safe_unordered_container_base::_M_detach_all () [protected], [inherited]
Detach all iterators, leaving them singular.

  void __gnu_debug::_Safe_unordered_container_base::_M_detach_local (_Safe_iterator_base *__it) [inherited]
Detach an iterator from this container

  void __gnu_debug::_Safe_unordered_container_base::_M_detach_local_single (_Safe_iterator_base *__it) [inherited]
Likewise but not thread safe.

  void __gnu_debug::_Safe_sequence_base::_M_detach_single (_Safe_iterator_base *__it) [inherited]
Likewise but not thread safe.

  void __gnu_debug::_Safe_sequence_base::_M_detach_singular () [protected], [inherited]
Detach all singular iterators.

Postcondition:
    for all iterators i attached to this sequence, i->_M_version == _M_version.

  __gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex () [protected], [inherited]
For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  void __gnu_debug::_Safe_sequence_base::_M_invalidate_all () const [inline], [inherited]
Invalidates all iterators.

Definition at line 242 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

  void __gnu_debug::_Safe_unordered_container< unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > >::_M_invalidate_if (_Predicate__pred) [inherited]
Invalidates all iterators x that reference this container, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

  void __gnu_debug::_Safe_unordered_container< unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > >::_M_invalidate_local_if (_Predicate__pred) [inherited]
Invalidates all local iterators x that reference this container, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal ilocal iterators nested in the safe ones.

  void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular () [protected], [inherited]
Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

  void __gnu_debug::_Safe_unordered_container_base::_M_swap (_Safe_unordered_container_base &__x) [protected], [inherited]
Swap this container with the given container. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

  void __gnu_debug::_Safe_sequence_base::_M_swap (_Safe_sequence_base &__x) [protected], [inherited]
Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

Member Data Documentation

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators [inherited]

The list of constant iterators that reference this container.

Definition at line 184 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  _Safe_iterator_base* __gnu_debug::_Safe_unordered_container_base::_M_const_local_iterators [inherited]

The list of constant local iterators that reference this container.

Definition at line 131 of file safe_unordered_base.h.

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators [inherited]

The list of mutable iterators that reference this container.

Definition at line 181 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  _Safe_iterator_base* __gnu_debug::_Safe_unordered_container_base::_M_local_iterators [inherited]

The list of mutable local iterators that reference this container.

Definition at line 128 of file safe_unordered_base.h.

  unsigned int __gnu_debug::_Safe_sequence_base::_M_version [mutable], [inherited]

The container version number. This number may never be 0.

Definition at line 187 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

Author

Generated automatically by Doxygen for libstdc++ from the source code.